
	global	_word_bitmask

	section	.data
	align	1
_word_bitmask
	dc.w	1
	dc.w	2
	dc.w	4
	dc.w	8
	dc.w	16
	dc.w	32
	dc.w	64
	dc.w	128
	dc.w	256
	dc.w	512
	dc.w	1024
	dc.w	2048
	dc.w	4096
	dc.w	8192
	dc.w	16384
	dc.w	-32768

	global	_byte_bitmask
_byte_bitmask
	dc.b	1
	dc.b	2
	dc.b	4
	dc.b	8
	dc.b	16
	dc.b	32
	dc.b	64
	dc.b	128

LC0	dc.b	00Ah,00Dh,064h,06Fh,068h,03Ah,020h,000h

	align	1	; ASM_OUTPUT_ASCII
	section	.text
	align	1

	global	_doh
_doh
	pshm	z
	ais	#-2
	tsz

	ste	0,z
	lde	#-1
	jsr	_green_leds
	lde	#LC0
	jsr	_print_string
	lde	0,z
	jsr	_print_string
	jsr	_SCI_drain
	lde	#1
	jsr	_reboot

	ais	#+2
	pulm	z
	rts

	align	1

	global	_isalnum
_isalnum
	pshm	z
	ais	#-6
	tsz

	ted	
	stab	0,z
	clrw	2,z
	addb	#-65
	cmpb	#25
	bls	L4
	
	ldab	0,z
	addb	#-97
	cmpb	#25
	bls	L4
	
	ldab	0,z
	clra	
	tde	
	jsr	_isdigit
	tstb	
	beq	L3
	

L4	ldd	#1
	std	2,z

L3	ldd	2,z

	ais	#+6
	pulm	z
	rts

	align	1

	global	_strcat
_strcat
	pshm	z
	ais	#-4
	tsz

	ste	0,z
	std	2,z
	jsr	_strlen
	lde	0,z
	ade	
	ldd	2,z
	jsr	_strcpyx

	ais	#+4
	pulm	z
	rts


	section	.data

LC1	dc.b	030h,031h,032h,033h,034h,035h,036h,037h
	dc.b	038h,039h,041h,042h,043h,044h,045h,046h
	dc.b	000h

	align	1	; ASM_OUTPUT_ASCII
	section	.text
	align	1

	global	_print_byte
_print_byte
	pshm	z
	ais	#-4
	tsz

	ted	
	stab	1,z
	lsrb	
	lsrb	
	lsrb	
	lsrb	
	stab	2,z
	clra	
	tde	
	tey	
	xgdy	
	addd	#LC1
	xgdy	
	ldab	0,y
	clra	
	tde	
	jsr	_putchar
	xgde	
	ldab	1,z
	xgde	
	ande	#15
	tey	
	xgdy	
	addd	#LC1
	xgdy	
	ldab	0,y
	clra	
	tde	
	jsr	_putchar

	ais	#+4
	pulm	z
	rts


	section	.data

LC2	dc.b	00Ah,00Dh,000h

	align	1	; ASM_OUTPUT_ASCII
	section	.text
	align	1

	global	_eol
_eol
	pshm	z
	tsz

	lde	#LC2
	jsr	_print_string
	pulm	z
	rts

	align	1

	global	_blank
_blank
	pshm	z
	tsz

	lde	#32
	jsr	_putchar
	pulm	z
	rts

	align	1

	global	_print_short
_print_short
	pshm	z
	ais	#-2
	tsz

	ste	0,z
	cpe	#9
	bls	L10
	
	ldx	#10
	ldd	0,z
	idiv	
	txe	
	jsr	_print_short

L10	lde	#10
	ldd	0,z
	tex	
	idiv	
	tde	
	ore	#48
	jsr	_putchar

	ais	#+2
	pulm	z
	rts

	align	1

	global	_print_02u
_print_02u
	pshm	z
	ais	#-8
	tsz

	ste	0,z
	ldd	#10
	std	2,z
	ldx	2,z
	ldd	0,z
	idiv	
	stx	6,z
	ldab	7,z
	addb	#48
	stab	4,z
	clra	
	tde	
	jsr	_putchar
	ldd	0,z
	ldx	2,z
	idiv	
	tde	
	ore	#48
	jsr	_putchar

	ais	#+8
	pulm	z
	rts

	align	1

	global	_print_signed_short
_print_signed_short
	pshm	z
	ais	#-2
	tsz

	ste	0,z
	ble	L13
	
	lde	#43
	jsr	_putchar
	lde	0,z
	jsr	_print_short
	bra	L12
	

L13	tstw	0,z
	bge	L14
	
	lde	#45
	jsr	_putchar
	lde	0,z
	nege	
	jsr	_print_short
	bra	L12
	

L14	lde	#32
	jsr	_putchar
	lde	#48
	jsr	_putchar

L12
	ais	#+2
	pulm	z
	rts

	align	1

	global	_print_short_N
_print_short_N
	pshm	z
	ais	#-2
	tsz

	ste	0,z
	tde	
	cpe	#1
	ble	L16
	
	ldx	#10
	ldd	0,z
	idiv	
	tey	
	xgdy	
	addd	#-1
	xgdy	
	txe	
	tyd	
	jsr	_print_short_N

L16	lde	#10
	ldd	0,z
	tex	
	idiv	
	tde	
	ore	#48
	jsr	_putchar

	ais	#+2
	pulm	z
	rts

	align	1

	global	_print_signed_long
_print_signed_long
	pshm	z
	ais	#-28
	tsz

	ste	16,z
	ldx	16,z
	tstw	0,x
	bge	L18
	
	lde	#45
	jsr	_putchar
	ldx	16,z
	ldx	0,x
	stx	20,z
	ldx	16,z
	ldx	2,x
	stx	22,z
	lde	20,z
	ldd	22,z
	jsr	_lnegate
	ste	12,z
	tzy	
	xgdy	
	addd	#12
	xgdy	
	std	2,y
	tze	
	tyd	
	bra	L30
	

L18	tze	
	ldd	16,z

L30	jsr	_sprint_010Lu
	stz	18,z
	ldab	0,z
	cmpb	#48
	bne	L31
	

L25	ldx	18,z
	tst	1,x
	beq	L31
	
	incw	18,z
	ldx	18,z
	ldab	0,x
	cmpb	#48
	beq	L25
	
	bra	L31
	

L28	ldx	18,z
	ldab	0,x
	clra	
	incw	18,z
	tde	
	jsr	_putchar

L31	ldx	18,z
	tst	0,x
	bne	L28
	

	ais	#+28
	pulm	z
	rts

	align	1

	global	_print_word
_print_word
	pshm	z
	ais	#-2
	tsz

	ste	0,z
	xgde	
	tab	
	clra	
	xgde	
	jsr	_print_byte
	ldab	1,z
	clra	
	tde	
	jsr	_print_byte

	ais	#+2
	pulm	z
	rts

	align	1

	global	_print_dword
_print_dword
	pshm	z
	ais	#-2
	tsz

	ste	0,z
	ldy	0,z
	ldab	0,y
	clra	
	tde	
	jsr	_print_byte
	ldy	0,z
	ldab	1,y
	clra	
	tde	
	jsr	_print_byte
	ldy	0,z
	ldab	2,y
	clra	
	tde	
	jsr	_print_byte
	ldy	0,z
	ldab	3,y
	clra	
	tde	
	jsr	_print_byte

	ais	#+2
	pulm	z
	rts

	align	1

	global	_print_buf
_print_buf
	pshm	z
	ais	#-4
	tsz

	ste	0,z
	std	2,z
	bra	L39
	

L37	ldy	0,z
	ldab	0,y
	clra	
	incw	0,z
	tde	
	jsr	_print_byte

L39	decw	2,z
	ldy	2,z
	cpy	#-1
	bne	L37
	

	ais	#+4
	pulm	z
	rts


	section	.data

LC3	dc.b	05Ch,078h,000h

	align	1	; ASM_OUTPUT_ASCII
	section	.text
	align	1

	global	_vis
_vis
	pshm	z
	ais	#-4
	tsz

	ste	0,z
	std	2,z
	bra	L49
	

L44	ldy	0,z
	ldab	0,y
	addb	#-33
	cmpb	#93
	bhi	L46
	
	ldab	0,y
	cmpb	#92
	bne	L45
	

L46	lde	#LC3
	jsr	_print_string
	ldy	0,z
	ldab	0,y
	clra	
	tde	
	jsr	_print_byte
	bra	L43
	

L45	ldy	0,z
	ldab	0,y
	clra	
	tde	
	jsr	_putchar

L43	incw	0,z

L49	decw	2,z
	ldy	2,z
	cpy	#-1
	bne	L44
	

	ais	#+4
	pulm	z
	rts

	align	1

	global	_ascii_num
_ascii_num
	pshm	z
	ais	#-6
	tsz

	ste	0,z
	std	4,z
	clry	

L51	ldx	0,z
	ldab	0,x
	incw	0,z
	addb	#-48
	stab	2,z
	cmpb	#9
	bhi	L54
	
	tye	
	asle	
	asle	
	tyd	
	ade	
	asle	
	tey	
	ldab	2,z
	clra	
	tde	
	xgey	
	ade	
	xgey	
	decw	4,z
	bne	L51
	
	tyd	
	bra	L56
	

L54	ldd	#-1

L56
	ais	#+6
	pulm	z
	rts

	align	1

	global	_ascii_hex
_ascii_hex
	pshm	z
	ais	#-4
	tsz

	tex	
	tdy	
	clre	

L58	ldab	0,x
	stab	0,z
	xgdx	
	addd	#1
	xgdx	
	addb	#-48
	stab	2,z
	cmpb	#9
	bls	L69
	
	ldab	0,z
	addb	#-65
	cmpb	#5
	bhi	L63
	
	ldab	0,z
	addb	#-55
	bra	L69
	

L63	ldab	0,z
	addb	#-97
	cmpb	#5
	bls	L65
	
	ldd	#-1
	bra	L68
	

L65	ldab	0,z
	addb	#-87

L69	stab	0,z
	asle	
	asle	
	asle	
	asle	
	ldab	0,z
	clra	
	pshm	d
	ore	-2,z
	ais	#+2
	xgdy	
	addd	#-1
	xgdy	
	lbne	L58
	
	ted	

L68
	ais	#+4
	pulm	z
	rts

	align	1

	global	_wildmat
_wildmat
	pshm	z
	ais	#-4
	tsz

	ste	0,z
	std	2,z
	jmp	L93
	

L74	ldy	0,z
	ldab	0,y
	cmpb	#42
	bne	L75
	

L76	incw	0,z
	ldy	0,z
	ldab	0,y
	cmpb	#42
	beq	L76
	
	ldy	0,z
	tst	0,y
	lbeq	L94
	
	bra	L81
	

L83	ldd	2,z
	incw	2,z
	lde	0,z
	jsr	_wildmat
	tstb	
	bne	L94
	

L81	ldy	2,z
	tst	0,y
	bne	L83
	

L96	clrd	
	bra	L92
	

L75	ldy	0,z
	ldab	0,y
	cmpb	#63
	bne	L86
	
	ldy	2,z
	tst	0,y
	bne	L73
	
	bra	L96
	

L86	ldy	2,z
	ldab	0,y
	ldy	0,z
	cmpb	0,y
	bne	L96
	

L73	incw	2,z
	incw	0,z

L93	ldy	0,z
	tst	0,y
	lbne	L74
	
	clrd	
	ldy	2,z
	tst	0,y
	bne	L92
	

L94	ldd	#1

L92
	ais	#+4
	pulm	z
	rts

	align	1

	global	_EDIVx_signed
_EDIVx_signed
	pshm	z
	ais	#-24
	tsz

	ste	4,z
	std	6,z
	tstw	4,z
	bge	L98
	
	lde	4,z
	ldd	6,z
	jsr	_lnegate
	ste	12,z
	std	14,z
	ldy	30,z
	sty	0,z
	ldy	32,z
	sty	2,z
	lde	12,z
	ldd	14,z
	jsr	_EDIVx
	ste	16,z
	std	18,z
	lde	16,z
	ldd	18,z
	jsr	_lnegate
	ste	8,z
	std	10,z
	lde	8,z
	ldd	10,z
	bra	L100
	

L98	ldy	30,z
	sty	0,z
	ldy	32,z
	sty	2,z
	lde	4,z
	ldd	6,z
	jsr	_EDIVx
	ste	20,z
	std	22,z
	lde	20,z
	ldd	22,z

L100
	ais	#+24
	pulm	z
	rts

	align	1

	global	_SCALE32_signed
_SCALE32_signed
	pshm	z
	ais	#-26
	tsz

	tey	
	std	4,z
	tstw	0,y
	bge	L102
	
	ldx	0,y
	stx	6,z
	ldy	2,y
	sty	8,z
	lde	6,z
	ldd	8,z
	jsr	_lnegate
	ste	0,z
	tzy	
	std	2,y
	tye	
	ldd	4,z
	jsr	_SCALE32
	ste	18,z
	std	20,z
	lde	18,z
	ldd	20,z
	jsr	_lnegate
	ste	14,z
	std	16,z
	lde	14,z
	ldd	16,z
	bra	L104
	

L102	tye	
	ldd	4,z
	jsr	_SCALE32
	ste	22,z
	std	24,z
	lde	22,z
	ldd	24,z

L104
	ais	#+26
	pulm	z
	rts



	end
